/*
  small class to filter positions and assign major minor.
  This class can be improved very much.

  Thorfinn sep 21 2012

 */

#include "shared.h"
#include "general.h"

#include "analysisFunction.h"
#include "soapReader.h" // <- for map, small hack very slow must update to faster DRAGON


typedef struct{
  int major;
  int minor;
}mm;


typedef std::map<loci,mm,cmp_loci > fMap;

fMap getMap(char *fname){
  const char *delims = "\t\n ";
  FILE *fp=getFILE(fname,"r");
  
  char buf[LENS];
  int nsites=0;
  fMap ret;
  while(fgets(buf,LENS,fp)){
    char *chr = strtok(buf,delims);
    strtok(NULL,delims);//rsnumber
    strtok(NULL,delims);//centimorgan
    int pos = atoi(strtok(NULL,delims))-1;//genomic position in bp
    mm mymm;
    mymm.major = refToInt[strtok(NULL,delims)[0]];
    mymm.minor = refToInt[strtok(NULL,delims)[0]];

    //check for N if this exists;
    if(mymm.major==4||mymm.minor==4){
      fprintf(stderr,"N extists in major minor defintion\n");
      break;
    }
    //    fprintf(stderr,"chr=%s pos=%d major=%d minor=%d\n",chr,pos,mymm.major,mymm.minor);
    loci tmp_loci = {chr,pos};
    fMap::iterator it = ret.find(tmp_loci);
    if(it!=ret.end()){
      fprintf(stderr,"duplicate entry in filterlist:%s : will exit offending position below\n",fname);
      fprintf(stderr,"chr=%s pos=%d major=%d minor=%d\n",chr,pos,mymm.major,mymm.minor);
      exit(0);
    }else
      ret.insert(fMap::value_type((loci){strdup(chr),pos}, mymm));
  }
  
  return ret;
}




class filter : public general{
  int doMajorMinor;
  int doFilter;
  char *fname;
  fMap fm;
public:
  //none optional stuff
  FILE *outfile;
  filter(argStruct *arguments);
  void getOptions(argStruct *arguments);
  void run(funkyPars  *pars);
  void clean(funkyPars *pars);
  void print(funkyPars *pars);
  void printArg(FILE *argFile);
  
};


filter::filter(argStruct *arguments){
  fprintf(stderr,"filter constructor\n");
  getOptions(arguments);


}


void filter::printArg(FILE *argFile){
  fprintf(argFile,"%s:\n\n",__FILE__);
  fprintf(argFile,"-filter\t%s\n",fname);
  fprintf(argFile,"-doMajorMinor\t%d\t\n",doMajorMinor);
  fprintf(argFile,"\n");
  
}


void filter::getOptions(argStruct *arguments){
  fname = NULL;
  doMajorMinor =0;
  doFilter =0;
  //from command line

  fname=angsd::getArg("-filter",fname,arguments);
  fprintf(stderr,"-fname=%s\n",fname);
  
  if(fname!=NULL)
    doFilter =1;


  doMajorMinor = angsd::getArg("-doMajorMinor",doMajorMinor,arguments);
  if(doMajorMinor==3 && doFilter==0){
    fprintf(stderr,"Must supply -filter \n");
    exit(0);
  }
  if(doFilter==0)
    return;

  
  printArg(arguments->argumentFile);
  
  fm = getMap(fname);
  fprintf(stderr,"[%s] number of sites to filter: %lu\n",__FILE__,fm.size());
}

void filter::run(funkyPars *p){
  p->keepSites=new int[p->numSites];
  p->results->freq->keepInd = new int[p->numSites];

  for(int s=0;s<p->numSites;s++){
    p->keepSites[s]=1;
    p->results->freq->keepInd[s]=p->nInd;  
  }
  if(doFilter && doMajorMinor==3){
    p->major= new int [p->numSites];
    p->minor= new int [p->numSites];
    for(int i=0;i<p->numSites;i++){
      p->major[i] = 4;
      p->minor[i] = 4;
    }
  }

  if(doFilter){
    for(int i=0;i<p->numSites;i++){
      fMap::iterator it = fm.find(p->sites[i]);
      if(it==fm.end()){
	p->keepSites[i] =0;
	continue;
      }
      if(it!=fm.end()&&doMajorMinor==3) {
	p->major[i] = it->second.major;
	p->minor[i] = it->second.minor;
	
      }
    }
  }
 
  
}
void filter::print(funkyPars *p){


}

void filter::clean(funkyPars *p){


}

